import re
import random
import string


def camel_case_to_snake_case(name):
    """
    Convertes a CamelCase name to snake_case
    :param name: the name to be converted
    :return:
    """
    s1 = re.sub('(.)([A-Z][a-z]+)', r'\1_\2', name)
    return re.sub('([a-z0-9])([A-Z])', r'\1_\2', s1).lower()


def snake_case_to_camel_case(name):
    """
    Convertes a snake_case name to CamelCase
    :param name: the name to be converted
    :return:
    """
    return ''.join(x.title() for x in name.split('_'))


def random_string_generator(str_size=30, allowed_chars=None):
    if not allowed_chars:
        allowed_chars = string.ascii_letters + string.digits
    return ''.join(random.choice(allowed_chars) for _ in range(str_size))

